<template>
  <div class="sw-gs-widget-product-insights">
    <SfAccordion transition="false" showChevron ref="productInsights">
      <!-- Actions -->
      <SwGsLayerProductActions :product="product" :additionalInfos="true" :detailLink="false"/>

      <!-- Product images -->
      <div v-if="product.media && product.media.length >= 1">
        <InsightsImages :images="product.media"></InsightsImages>
      </div>

      <!-- General information -->
      <SwGsAccordionItem :header="$t('General Information')"
                         class="product-insights-general-item">
        <InsightsGeneral :product="product"></InsightsGeneral>
      </SwGsAccordionItem>

      <!-- Prices -->
      <SwGsAccordionItem :header="$t('Prices')"
                         class="product-insights-prices-item">
        <InsightsPrices :product="product"></InsightsPrices>
      </SwGsAccordionItem>

      <!-- Deliverability -->
      <SwGsAccordionItem :header="$t('Deliverability')"
                         class="product-insights-deliverability-item">
        <InsightsDeliverability :product="product"></InsightsDeliverability>
      </SwGsAccordionItem>

      <!-- Specifications -->
      <SwGsAccordionItem :header="$t('Specifications')"
                         class="product-insights-specifications-item">
        <InsightsSpecifications :product="product"></InsightsSpecifications>
      </SwGsAccordionItem>

      <!-- Properties -->
      <SwGsAccordionItem v-if="product.properties && product.properties.length >= 1"
                         :header="$t('Properties')"
                         class="product-insights-properties-item">
        <InsightsProperties :product="product" :key="product.id"></InsightsProperties>
      </SwGsAccordionItem>

      <!-- Custom fields -->
      <SwGsAccordionItem v-if="customFieldsCount > 0"
                         :header="$t('Custom fields')"
                         class="product-insights-custom-fields-item">
        <InsightsCustomFields :product="product"></InsightsCustomFields>
      </SwGsAccordionItem>

      <!-- Filter collection -->
      <div class="product-insights-filter-item">
        <InsightsFilter :product="product"></InsightsFilter>
      </div>
    </SfAccordion>
  </div>
</template>

<script lang="ts">
  import {ref, computed, onMounted} from "@vue/composition-api";
  import {SfAccordion} from "@storefront-ui/vue";
  import SwGsAccordionItem from "../layer/SwGsAccordionItem.vue";
  import SwGsLayerProductActions from "../layer/SwGsLayerProductActions.vue";
  import InsightsImages from "./product-insights/InsightsImages.vue";
  import InsightsGeneral from "./product-insights/InsightsGeneral.vue";
  import InsightsPrices from "./product-insights/InsightsPrices.vue";
  import InsightsDeliverability from "./product-insights/InsightsDeliverability.vue";
  import InsightsSpecifications from "./product-insights/InsightsSpecifications.vue";
  import InsightsProperties from "./product-insights/InsightsProperties.vue";
  import InsightsCustomFields from "./product-insights/InsightsCustomFields.vue";
  import InsightsFilter from "./product-insights/InsightsFilter.vue";

  export default {
    name: "SwGsProductInsights",
    components: {
      SfAccordion,
      SwGsAccordionItem,
      SwGsLayerProductActions,
      InsightsImages,
      InsightsGeneral,
      InsightsPrices,
      InsightsDeliverability,
      InsightsSpecifications,
      InsightsProperties,
      InsightsCustomFields,
      InsightsFilter
    },
    props: {
      slotContext: {
        type: [Object,Array,String],
        default: null,
      }
    },
    setup(props, {}) {
      const product = ref(props.slotContext);
      const productInsights = ref(null);

      const openFirstVisibleAccordion = (rootElement) => {
        if (!rootElement) return;

        let found = false;
        rootElement.$children.forEach((child) => {
          if (found) return;
          if (child.$options._componentTag !== 'SwGsAccordionItem') return;

          const element = child.$el;
          const hidden = window.getComputedStyle(element).getPropertyValue('display') == 'none';
          if (hidden) return;

          found = true;
          child.accordionClick();
        });
      }

      onMounted(() => {
        openFirstVisibleAccordion(productInsights.value);
      });

      return {
        product,
        productInsights,
        customFieldsCount: computed(() => Object.keys(product.value.customFields || {}).length)
      }
    },
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-widget-product-insights {
    ::v-deep {
      .product-insights-row {
        margin-bottom: 8px;

        &.has-cols {
          display: flex;
          margin-left: -5px;
          margin-right: -5px;

          .product-insights-label,
          .product-insights-value {
            padding: 0 5px;
          }

          &.in-third {
            .product-insights-col {
              width: 33.3%;
            }
          }

          &.in-half {
            .product-insights-col {
              width: 50%;
            }
          }
        }
      }

      .product-insights-label,
      .product-insights-value {
        font-size: var(--font-size--sm);
      }

      .product-insights-value {
        color: var(--c-gray-variant);

        .is-true {
          color: var(--c-primary);
        }
      }

      .sf-accordion-item__header {
        padding: 5px 0;
        margin-bottom: 5px;
        border-bottom: 2px solid var(--c-primary);
      }
    }
  }
</style>
